const {execSync} = require('node:child_process');
const fs = require('node:fs');
const {version} = require("./package.json");


async function genArtefact() {
    return {
        "branch": '' + execSync("git symbolic-ref --short HEAD"),
        "appTitle": "Binder",
        "buildTimestamp": Date.now(),
        "version": version,
        "CommitSHA": '' + execSync("git rev-parse HEAD"),
    }
}

async function genBuildInfo() {
    const buildArtefact = await genArtefact();
    fs.writeFileSync("buildInfo.json", JSON.stringify(buildArtefact));
}


module.exports = {
    genBuildInfo
}
