import fs from 'node:fs';
import path from 'node:path';
import {app} from 'electron';

const devBuildInfo = {
  "branch": "~DEVELOPMENT NOT FOR REDISTRIBUTION~",
  "appTitle": "~BINDER - TEST - NOT FOR RELEASE~",
  "buildTimestamp": -380484000000,
  "version": "reee.eee.eee.eee",
}

function getBuildInfo(devMode = true) {
  const buildInfoPath = path.join(app.getAppPath(), "buildInfo.json");

  try {
    const readData = fs.readFileSync(buildInfoPath, 'utf8');
    const dynamicBuildInfo = JSON.parse(readData);
    if (devMode) {
      dynamicBuildInfo.appTitle += "-test";
    }

    return dynamicBuildInfo;

  } catch(e) {
    console.log("failed to load buildinfo " + e);
  }
}

export {getBuildInfo}