import React from 'react'
import { StatorObjectBase, StatorContext } from '../statorobject';
import { NewBinderOverlay } from "./newbinderoverlay";
import { AboutOverlay } from './aboutoverlay';
import { ActivationOverlay } from './activationoverlay';
import { UpdaterOverlay } from './updateroverlay';

//Todo okay so this is janky
// I never intended this to be the central point to install new overlays...
// This process needs to be done functionally.
// (cept, you still need to be able to refer to them programatically... idek)
export enum OverlayStatorStates
{
  showNone,
  showNewBinder,
  showActivation,
  showAbout,
  showUpdater,
}

class OverlayStator extends StatorObjectBase
{
  myShowState = OverlayStatorStates.showNone;

  closeOverlays()
  {
    this.myShowState = OverlayStatorStates.showNone;
    this.publishChanges();
  }

  set(state: OverlayStatorStates)
  {
    this.myShowState = state;
    this.publishChanges();
  }
}

const overlayStatorKey = "OverlayStator";
function useWatchOverlayStator(appContext: StatorContext)
{
  return appContext.useWatchStatorLegacy(overlayStatorKey, new OverlayStator(appContext))
}

function getOverlayStator(appContext: StatorContext)
{
  return appContext.getStatorLegacy(overlayStatorKey, new OverlayStator(appContext)) as OverlayStator;
}


interface OverlayProps
{
  appContext: StatorContext;
}


function Overlays(props: OverlayProps)
{
  const myStator = useWatchOverlayStator(props.appContext);

  switch(myStator.myShowState)
  {
    case OverlayStatorStates.showAbout:
      return (<AboutOverlay appContext={props.appContext}/>);
    case OverlayStatorStates.showNewBinder:
      return (<NewBinderOverlay appContext={props.appContext}/>);
    case OverlayStatorStates.showActivation:
      return (<ActivationOverlay appContext={props.appContext}/>);
    case OverlayStatorStates.showUpdater:
      return (<UpdaterOverlay appContext={props.appContext}/>);
    case OverlayStatorStates.showNone: return null;
  }
}

export { Overlays, getOverlayStator }