import {StatorContext, StatorObjectBase} from "../statorobject";

class SidebarStator extends StatorObjectBase {
    tagSidebarHidden = false;
    objectPropertiesHidden = true;

    toggleTagSidebar() {
        this.tagSidebarHidden = !this.tagSidebarHidden;
        this.publishChanges();
    }

    toggleObjectProperties() {
        this.objectPropertiesHidden = !this.objectPropertiesHidden;
        this.publishChanges();
    }
}

const SidebarStatorKey = "SidebarStatorKeyKey";

function useWatchSidebarStator(appContext: StatorContext)
{
    return appContext.useWatchStatorLegacy(SidebarStatorKey, new SidebarStator(appContext)) as SidebarStator;
}

function getSidebarStator(appContext: StatorContext)
{
    return appContext.getStatorLegacy(SidebarStatorKey, new SidebarStator(appContext)) as SidebarStator;
}


export { useWatchSidebarStator, getSidebarStator }