//It would be a lot better if it would check the first one past the startingPoint, because
// we use this a lot to check to make sure we have the last one, and if the file is the 1000th
// then as it stands it'll start by looking for 1500... even if 1001 doesn't exist...
// fast *enough* but meh
async function findEndOfUnboundedList(startingPoint: number, predicate: (index: number) => Promise<boolean>): Promise<number> {
    //Basically an exponential search

    let lowerBound = 0;
    let upperBound: number | undefined = 0;

    let currentIndex = startingPoint;
    while(!upperBound) {
        if(await predicate(currentIndex)) {
            lowerBound = currentIndex;
        } else {
            upperBound = currentIndex;
        }

        //Do this last, we want to start with the startingPoint
        if (currentIndex)
            currentIndex = currentIndex * 2;
        else
            currentIndex = 1;
    }

    while(lowerBound != upperBound - 1) {
        const range = Math.trunc(upperBound - lowerBound);
        const i: number = lowerBound + Math.trunc(range / 2);

        if(await predicate(i)) {
            lowerBound = i;
        } else {
            upperBound = i;
        }
    }

    return lowerBound;
}

export {findEndOfUnboundedList}