const { contextBridge, ipcRenderer } = require('electron');



contextBridge.exposeInMainWorld('metaApi',
{
    dirName: function() {
        return ipcRenderer.invoke("dirName");
    },
    justDie: function()
    {
        ipcRenderer.invoke('just-die');
    },
    getAuthKey: async function()
    {
        const result = await ipcRenderer.invoke('get-auth-key');
        console.log("Got auth token: " + result);
        return result;
    },
    getServerEndpoint: async function() {
        return ipcRenderer.invoke("get-server-endpoint");
    },
    getLicensePath: function() {
        return ipcRenderer.invoke("get-license-path");
    },
    openUrl: function(url)
    {
        ipcRenderer.invoke("open-url", url);
    },
    openSelectDirectory: function()
    {
        return ipcRenderer.invoke('open-select-directory');
    },
    getBuildInfo: function() {
        return ipcRenderer.invoke('get-build-info');
    },
    spawnMenu: function(args)
    {
        ipcRenderer.invoke('spawn-menu', args);
    },

    getConfigPath: async () => {
        return ipcRenderer.invoke('getConfigDirPath');
    },

    joinPath: async (base, second) => {
        return ipcRenderer.invoke('joinPath', base, second);
    },

    baseNameOfPath: async (path) => {
        return ipcRenderer.invoke('baseNameOfPath', path);
    },

    checkPathExists: async (path) => {
        return ipcRenderer.invoke('checkPathExists', path);
    },

    writeFile: async (path, data, encoding) => {
        return ipcRenderer.invoke('writeFile', path, data, encoding);
    },

    readFile: async (path, encoding) => {
        return ipcRenderer.invoke('readFile', path, encoding);
    },

    appendUtf8File: async (path, data) => {
        return ipcRenderer.invoke('appendUtf8File', path, data);
    },

    readUtf8File: async (path, encoding) => {
        return ipcRenderer.invoke('readUtf8File', path);
    },

    readMime: async (path) => {
        return ipcRenderer.invoke('readMime', path);
    },

    createDirectories: async (path) => {
        return ipcRenderer.invoke('createDirectories', path);
    },

    readFileModTime: async (path) => {
        return ipcRenderer.invoke('readFileModTime', path);
    },

    readFileStats: async (path) => {
        return ipcRenderer.invoke('readFileStats', path);
    },

    listPaths: async (path) => {
        return ipcRenderer.invoke('listPaths', path);
    },

    copyPath: async (to, from) => {
        return ipcRenderer.invoke('copyPath', to, from);
    },

    renamePath: async (path, newPath) => {
        return ipcRenderer.invoke('renamePath', path, newPath);
    },

    removePath: async (path) => {
        return ipcRenderer.invoke('removePath', path);
    },

    acquireLockfile: async (path) => {
        return ipcRenderer.invoke('acquireLockfile', path);
    },

    releaseLockfile: async (path) => {
        return ipcRenderer.invoke('releaseLockfile', path);
    },

    watchFile: async (path) => {
        return ipcRenderer.invoke('watchFile', path);
    },

    unwatchFile: async (path) => {
        return ipcRenderer.invoke('unwatchFile', path);
    },

    takeChecksumOfFile: async (path, checksumType) => {
        return ipcRenderer.invoke('takeChecksumOfFile', path, checksumType);
    },

    registerGlobalFileChangeHandler: (callback) => {
        console.log("On file change?");
        /*
        ipcRenderer.on('fileChange', (event, ...args) => {
            callback(args);
        });
        */
    },

    generateThumbnailSharp: async (source, dest) => {
        return ipcRenderer.invoke("generateThumbnailSharp", source, dest);
    },

    longPollThumbnailJob: async (jobId) => {
        return ipcRenderer.invoke("longPollThumbnailJob", jobId);
    },

    backendEntrypoint: async function(endpoint, body)
    {
        return await ipcRenderer.invoke('backend-entrypoint', endpoint, body);
    }

});


console.log("preload");
