function parseTagName(tagName: string) {
    if(!tagName || tagName == "") {
        return "";
    }
    const parseFunctionName = "!!binder-function-time(";
    const functionDelimiter = ")!!";

    if (!tagName.startsWith(parseFunctionName)) {
        return tagName;
    }

    if(!tagName.endsWith(")!!"))
        return tagName;

    const unixTimestamp = parseInt(tagName.substring(parseFunctionName.length, tagName.length - functionDelimiter.length));
    //console.log(unixTimestamp);

    const dateObject = new Date(unixTimestamp / 1000 / 1000); //cause we know it's a nanosecond timestamp

    const result = dateObject.toLocaleDateString() + " @ " + dateObject.toLocaleTimeString();
    //console.log(result);

    return result;
}

export {parseTagName}